/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.175 by jmc, Wed Aug 15 23:19:21 2012 UTC revision 1.186 by jmc, Tue Jul 9 22:11:47 2013 UTC
# Line 322  testoutput_run() Line 322  testoutput_run()
322          'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $refoutp ; yy=$? ;;          'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $refoutp ; yy=$? ;;
323          'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $refoutp ; yy=$? ;;          'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $refoutp ; yy=$? ;;
324          'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $refoutp ; yy=$? ;;          'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $refoutp ; yy=$? ;;
325          'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Global"    $2 $refoutp ; yy=$? ;;          'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Glob-ave"  $2 $refoutp ; yy=$? ;;
326          'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South"     $2 $refoutp ; yy=$? ;;          'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South-av"  $2 $refoutp ; yy=$? ;;
327          'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North"     $2 $refoutp ; yy=$? ;;          'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North-av"  $2 $refoutp ; yy=$? ;;
328            'HthMxS') testoutput_var $1 "thSI_IceH_max_S" "thSIc H South-max" $2 $refoutp ; yy=$? ;;
329            'HthMxN') testoutput_var $1 "thSI_IceH_max_N" "thSIc H North-max" $2 $refoutp ; yy=$? ;;
330            'StrmIc') testoutput_var $1 "STREAMICE_FP_ERR" "StreamIce Solver" $2 $refoutp ; yy=$? ;;
331                *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;                *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
332            esac            esac
333            if test $xx = $sVar            if test $xx = $sVar
# Line 467  run_clean() Line 470  run_clean()
470              rm -f $RUNLOG *.txt STD* w2_tile_topology.????.log *diagnostics.log datetime              rm -f $RUNLOG *.txt STD* w2_tile_topology.????.log *diagnostics.log datetime
471              rm -rf mnc_test_*              rm -rf mnc_test_*
472              rm -f *_MIT_CE_000.opt0000 costfunction*0000              rm -f *_MIT_CE_000.opt0000 costfunction*0000
473                rm -f oad_cp.000.[0-9][0-9][0-9][0-9][0-9]
474              echo successful              echo successful
475              exit 0              exit 0
476          )          )
# Line 534  makemodel() Line 538  makemodel()
538              mk_fail=2              mk_fail=2
539          fi          fi
540      fi      fi
541        if test $KIND = 1 -a -f taf_ftl.log ; then
542            head -1 taf_ftl.log >> $CDIR"/summary.txt"
543        fi
544      if test $KIND = 2 -a -f taf_ad.log ; then      if test $KIND = 2 -a -f taf_ad.log ; then
545              head -1 taf_ad.log >> $CDIR"/summary.txt"          head -1 taf_ad.log >> $CDIR"/summary.txt"
546              nerr=`grep -c 'TAF *.* ERROR ' taf_ad.log`          nerr=`grep -c 'TAF *.* ERROR ' taf_ad.log`
547              nwar=`grep -c 'TAF RECOMPUTATION *.* WARNING ' taf_ad.log`          nwar=`grep -c 'TAF RECOMPUTATION *.* WARNING ' taf_ad.log`
548              echo " TAF reports $nerr Errors and $nwar Recomputation Warnings" \          if test -f taf_output ; then
549                n2er=`grep -c 'TAF *.* ERROR ' taf_output`
550                nerr=`expr $nerr + $n2er`
551            fi
552            echo " TAF reports $nerr Errors and $nwar Recomputation Warnings" \
553                                  >> $CDIR"/summary.txt"                                  >> $CDIR"/summary.txt"
554      fi      fi
555      if test $mk_fail != 0 ; then return $mk_fail ; fi      if test $mk_fail != 0 ; then return $mk_fail ; fi
# Line 802  runmodel() Line 813  runmodel()
813            fi            fi
814          fi          fi
815          rm -f run.log_tmp          rm -f run.log_tmp
816          #- in all cases where OutputFile exists, report SIZE (and AD time)          #- in all cases where OutputFile exists, report SIZE and time
817          if test -f $OUTPUTFILE ; then          if test -f $OUTPUTFILE ; then
818            grep '(PID\.TID 0000\.0001)      n.. =' $OUTPUTFILE \            grep '(PID\.TID 0000\.0001)      n.. =' $OUTPUTFILE \
819                  | sed 's/(PID.TID 0000.0001)     //' >> $CDIR"/summary.txt"                  | sed 's/(PID.TID 0000.0001)   //' >> $CDIR"/summary.txt"
820            if test $KIND = 2 ; then            grep -A3 'Seconds in section "ALL' $OUTPUTFILE \
821              grep -A3 'Seconds in section "ALL' $OUTPUTFILE >> $CDIR"/summary.txt"                  | sed 's/(PID.TID 0000.0001)   //' >> $CDIR"/summary.txt"
           fi  
822          fi          fi
823          if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi          if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
824          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
# Line 910  formatresults() Line 920  formatresults()
920          fi          fi
921      fi      fi
922      printf '  %s' $nm      printf '  %s' $nm
923        if test $KIND = 2 ; then
924            #-- apppend taf repport summary:
925            tafrep=`grep -c '^ TAF reports ' $CDIR/summary.txt`
926            if test $tafrep = 1 ; then
927                grep '^ TAF reports ' $CDIR/summary.txt | awk '{printf "  (e=%i, w=%i)",$3,$6}'
928            fi
929        fi
930      printf '\n'      printf '\n'
931    
932  }  }
# Line 1278  else Line 1295  else
1295  fi  fi
1296    
1297  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
1298  if test -x tr_cmpnum ; then  if test "x$CLEANUP" = xt -o -x tr_cmpnum ; then
1299      echo "skipping comparison code build"      echo "skipping comparison code build"
1300  else  else
1301      createcodelet      createcodelet
# Line 1294  fi Line 1311  fi
1311  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
1312  CMDLINE=$0  CMDLINE=$0
1313  for xx in "$@" ; do nw=`echo $xx | wc -w`  for xx in "$@" ; do nw=`echo $xx | wc -w`
1314      if test $nw = '1' ; then CMDLINE="$CMDLINE $xx"      if test $nw = '1' ; then CMDLINE="$CMDLINE $xx" ; else
1315                          else CMDLINE="$CMDLINE '$xx'" ; fi        nb=`echo $xx | grep -c '='`
1316          if test $nb = 0 ; then CMDLINE="$CMDLINE '$xx'"
1317          else yy=`echo "$xx'" | sed "s/=/='/"` ;
1318                                 CMDLINE="$CMDLINE $yy" ; fi
1319        fi
1320  done  done
1321  #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done  #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
1322  MACH=`hostname`  MACH=`hostname`
# Line 1342  if test "x$OPTFILE" != xNONE ; then Line 1363  if test "x$OPTFILE" != xNONE ; then
1363          echo >> $SUMMARY          echo >> $SUMMARY
1364          echo "  OPTFILE=$OPTFILE" >> $SUMMARY          echo "  OPTFILE=$OPTFILE" >> $SUMMARY
1365      else      else
1366          echo | tee $SUMMARY          echo | tee -a $SUMMARY
1367          echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee $SUMMARY          echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee -a $SUMMARY
1368          exit 1          exit 1
1369      fi      fi
1370  else  else
# Line 1370  if test $KIND = 0 ; then Line 1391  if test $KIND = 0 ; then
1391  else  else
1392      line_0=`printf '%s %2i' 'default   ' $MATCH_CRIT`      line_0=`printf '%s %2i' 'default   ' $MATCH_CRIT`
1393    if test $KIND = 1 ; then    if test $KIND = 1 ; then
1394      echo "TANGLIN=true" >> $SUMMARY     #echo "TANGLIN=true" >> $SUMMARY
1395        echo "TangLin generated by TAF" >> $SUMMARY
1396      elif test $KIND = 3 ; then
1397        echo "TangLin generated by OpenAD" >> $SUMMARY
1398      elif test $KIND = 2 ; then
1399       #echo "ADJOINT=true" >> $SUMMARY
1400        echo "Adjoint generated by TAF" >> $SUMMARY
1401      else
1402        echo "Adjoint generated by OpenAD" >> $SUMMARY
1403      fi
1404      if test $KIND = 1 -o $KIND = 3 ; then
1405      line_1="G D M    C  T  F"      line_1="G D M    C  T  F"
1406      line_2="e p a R  o  L  D"      line_2="e p a R  o  L  D"
1407    else    else
     echo "ADJOINT=true" >> $SUMMARY  
1408      line_1="G D M    C  A  F"      line_1="G D M    C  A  F"
1409      line_2="e p a R  o  d  D"      line_2="e p a R  o  d  D"
1410    fi    fi
# Line 1382  else Line 1412  else
1412      line_4="2 d e n  t  r  r"      line_4="2 d e n  t  r  r"
1413      echo >> $SUMMARY      echo >> $SUMMARY
1414  fi  fi
1415    if test "x$CLEANUP" != xt ; then
1416      echo "$line_0" | tee -a $SUMMARY      echo "$line_0" | tee -a $SUMMARY
1417      echo "$line_1" | tee -a $SUMMARY      echo "$line_1" | tee -a $SUMMARY
1418      echo "$line_2" | tee -a $SUMMARY      echo "$line_2" | tee -a $SUMMARY
1419      echo "$line_3" | tee -a $SUMMARY      echo "$line_3" | tee -a $SUMMARY
1420      echo "$line_4" | tee -a $SUMMARY      echo "$line_4" | tee -a $SUMMARY
1421      echo ""        | tee -a $SUMMARY      echo ""        | tee -a $SUMMARY
1422    fi
1423  echo "-------------------------------------------------------------------------------"  echo "-------------------------------------------------------------------------------"
1424    
1425  #  ...and each test directory...  #  ...and each test directory...
# Line 1496  for dir in $TESTDIRS ; do Line 1528  for dir in $TESTDIRS ; do
1528      #  Check whether there are "extra runs" for this testdir      #  Check whether there are "extra runs" for this testdir
1529      extra_runs=      extra_runs=
1530      if test "x$NORUN" = xf ; then      if test "x$NORUN" = xf ; then
1531          ex_run_dirs=`( cd $dir ; echo $inputdir.* )`          ex_run_dirs=`( cd $dir ; ls -d $inputdir.* 2> /dev/null )`
1532      fi      fi
1533      #echo "ex_run_dirs='$ex_run_dirs'"      #echo "ex_run_dirs='$ex_run_dirs'"
1534      for exd in $ex_run_dirs ; do      for exd in $ex_run_dirs ; do
1535          name=`echo $exd | sed -e "s/$inputdir\.//"`          name=`echo $exd | sed -e "s/$inputdir\.//"`
1536          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1537          outf="$dir/results/$refExOut"          outf="$dir/results/$refExOut"
         #if test -f $outf -a -r $outf ; then  
1538          if test -r $outf -o -r ${outf}.gz ; then          if test -r $outf -o -r ${outf}.gz ; then
1539            if test "x$MULTI_THREAD" = "xt" ; then            if test "x$MULTI_THREAD" = "xt" ; then
1540              if test -r $dir"/"$exd"/eedata.mth" ; then              if test -r $dir"/"$exd"/eedata.mth" ; then
# Line 1587  for dir in $TESTDIRS ; do Line 1618  for dir in $TESTDIRS ; do
1618              linkdata $dir/$pfxdir.$ex $inputdir.$ex $inputdir              linkdata $dir/$pfxdir.$ex $inputdir.$ex $inputdir
1619              runmodel $dir/$pfxdir.$ex && run=Y \              runmodel $dir/$pfxdir.$ex && run=Y \
1620              && results=`testoutput_run $dir $pfxdir.$ex $refExOut`              && results=`testoutput_run $dir $pfxdir.$ex $refExOut`
1621              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`              fres=`formatresults $dir.$ex ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
             fres="$fres.$ex"  
1622              echo 1>&2              echo 1>&2
1623              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1624              echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $locDIR"/summary.txt"              echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $locDIR"/summary.txt"
# Line 1597  for dir in $TESTDIRS ; do Line 1627  for dir in $TESTDIRS ; do
1627              fi              fi
1628          done          done
1629    
1630      if test -f $DRESULTS"/"genmake_state ; then : ; else      if test ! -f $DRESULTS"/"genmake_state ; then
1631          if test -f $dir/$builddir/Makefile ; then          if test -f $dir/$builddir/Makefile ; then
1632              mkOpt=`grep '^# OPTFILE=' $dir/$builddir/Makefile 2>/dev/null | head -1 | sed 's/^# //'`              mkOpt=`grep '^# OPTFILE=' $dir/$builddir/Makefile 2>/dev/null | head -1 | sed 's/^# //'`
1633              echo "from '$dir/$builddir/Makefile', extract:" > $DRESULTS/genmake_state              echo "from '$dir/$builddir/Makefile', extract:" > $DRESULTS/genmake_state
# Line 1606  for dir in $TESTDIRS ; do Line 1636  for dir in $TESTDIRS ; do
1636              if test "x$OPTFILE" = xNONE ; then              if test "x$OPTFILE" = xNONE ; then
1637                  eval $mkOpt                  eval $mkOpt
1638                  sed "/^No \"OPTFILE\" was specified ; genmake2/a\  OPTFILE=${OPTFILE}"\                  sed "/^No \"OPTFILE\" was specified ; genmake2/a\  OPTFILE=${OPTFILE}"\
1639                          $SUMMARY > tr_0.tmp_log                          $SUMMARY > tmp.tr_log
1640                  RETVAL=$?                  RETVAL=$?
1641                  if test "x$RETVAL" = x0 ; then rm -f $SUMMARY                  if test "x$RETVAL" = x0 ; then rm -f $SUMMARY
1642                          cp tr_0.tmp_log $SUMMARY                          cp tmp.tr_log $SUMMARY
1643                  else rm -f tr_0.tmp_log                  else rm -f tmp.tr_log
1644                  fi                  fi
1645              fi              fi
1646              gmkLog=$dir/$builddir/genmake.log              gmkLog=$dir/$builddir/genmake.log
1647              grep '^Get compiler version using:' $gmkLog > /dev/null 2>&1              if test -r $gmkLog ; then
1648              RETVAL=$?                  grep '^Get compiler version using:' $gmkLog > /dev/null 2>&1
1649              if test "x$RETVAL" = x0 ; then                  RETVAL=$?
1650                  echo "from '$gmkLog', extract compiler version:" >> $DRESULTS/genmake_state                  if test "x$RETVAL" = x0 ; then
1651                  sed -n '/Get compiler version/,/<-- compiler version/p' $gmkLog \                    echo -n "from '$gmkLog', " >> $DRESULTS/genmake_state
1652                          | grep -v '^... compiler version ' > tr_1.tmp_log                    echo "extract compiler version:"   >> $DRESULTS/genmake_state
1653                  sed -n '1p' tr_1.tmp_log >> $DRESULTS/genmake_state                    sed -n '/Get compiler version/,/<-- compiler version/p' \
1654                  sed -n '2,/^$/p' tr_1.tmp_log | sed '/^$/d' | sed 's/^./ &/' \                       $gmkLog | grep -v '^... compiler version ' > tmp.tr_log
1655                          >> $DRESULTS/genmake_state                    sed -n '1p' tmp.tr_log >> $DRESULTS/genmake_state
1656                  rm -f tr_1.tmp_log                    sed -n '2,/^$/p' tmp.tr_log | sed '/^$/d' | sed 's/^./ &/' \
1657                                             >> $DRESULTS/genmake_state
1658                      rm -f tmp.tr_log
1659                    fi
1660                    echo -n "from '$gmkLog', " >> $DRESULTS/genmake_state
1661                    echo "get NETCDF & LAPACK settings:" >> $DRESULTS/genmake_state
1662                    sed -n '/set HAVE_NETCDF=/p' $gmkLog >> $DRESULTS/genmake_state
1663                    sed -n '/set HAVE_LAPACK=/p' $gmkLog >> $DRESULTS/genmake_state
1664              fi              fi
1665          fi          fi
1666      fi      fi
# Line 1685  fi Line 1722  fi
1722  if test "x$DELDIR" = xt ; then  if test "x$DELDIR" = xt ; then
1723      rm -rf $DRESULTS      rm -rf $DRESULTS
1724  fi  fi
1725    echo "======== End of testreport execution ========"

Legend:
Removed from v.1.175  
changed lines
  Added in v.1.186

  ViewVC Help
Powered by ViewVC 1.1.22